package be.seeseemelk.llamascript;

import io.github.ollama4j.OllamaAPI;
import lombok.Setter;

import java.util.Objects;

@Setter
public class LLamaScriptFactory {
    private String host;
    private String model;

    public LLamaScriptFactory() {
        host = Objects.requireNonNullElse(System.getenv("OLLAMA_HOST"), "http://localhost:11434");
        model = Objects.requireNonNullElse(System.getenv("OLLAMA_MODEL"), "llama3.1:8b");
    }

    public LlamaScript build() {
        return new LlamaScript(buildWorker());
    }

    private LlamaScriptWorker buildWorker() {
        return LlamaScriptWorker.builder()
                .api(new OllamaAPI(host))
                .model(model)
                .build();
    }
}
