package be.seeseemelk.llamascript.autoconfigure;

import be.seeseemelk.llamascript.LLamaScriptFactory;
import be.seeseemelk.llamascript.LlamaScript;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@EnableConfigurationProperties(LlamaScriptProperties.class)
public class LlamaScriptAutoConfiguration {
    @Autowired
    private LlamaScriptProperties properties;

    @Bean
    @ConditionalOnMissingBean
    public LLamaScriptFactory lLamaScriptFactory() {
        var factory = new LLamaScriptFactory();
        factory.setHost(properties.getHost());
        factory.setModel(properties.getModel());
        return factory;
    }

    @Bean
    @ConditionalOnMissingBean
    public LlamaScript llamaScript(LLamaScriptFactory factory) {
        return factory.build();
    }
}
